//+------------------------------------------------------------------+
//|                                            iMax MTF DETECTOR.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, KG"

#property indicator_chart_window
#property indicator_buffers 0

extern int Corner=1;
extern int x_distance=0;
extern int y_distance=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   string label6xx = "iMAX_TITLE";
   ObjectDelete(label6xx);
   ObjectCreate( label6xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(label6xx,"iMAX",9, "Arial Bold", RoyalBlue);
   ObjectSet( label6xx, OBJPROP_CORNER, Corner );
   ObjectSet( label6xx, OBJPROP_XDISTANCE, 230+x_distance );
   ObjectSet( label6xx, OBJPROP_YDISTANCE, 10+y_distance );

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
   ObjectDelete("iMAX_TITLE");
    
   ObjectDelete("iMAX MN1");  
   ObjectDelete("iMAX W1");   
   ObjectDelete("iMAX D1");
   ObjectDelete("iMAX H4");
   ObjectDelete("iMAX H1");
   ObjectDelete("iMAX M30");
   ObjectDelete("iMAX M15");
   ObjectDelete("iMAX M5");
   ObjectDelete("iMAX M1");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   
   string Sign;   
   color Col;
   
   
   double iMAX_Curr=iCustom(NULL, PERIOD_MN1, "iMAX",0,0);
   double iMAX_Prev=iCustom(NULL, PERIOD_MN1, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="MN"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="MN"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="MN"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="MN"; Col=Tomato; } //Trend Down Weak
   string sign112xx = "iMAX MN1";
   ObjectDelete(sign112xx);
   ObjectCreate(sign112xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign112xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign112xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign112xx, OBJPROP_XDISTANCE, 13+x_distance );
   ObjectSet(sign112xx, OBJPROP_YDISTANCE, 10+y_distance );
         
   iMAX_Curr=iCustom(NULL, PERIOD_W1, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_W1, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="W1"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="W1"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="W1"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="W1"; Col=Tomato; } //Trend Down Weak
   string sign1xx = "iMAX W1";
   ObjectDelete(sign1xx);
   ObjectCreate(sign1xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign1xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign1xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign1xx, OBJPROP_XDISTANCE, 35+x_distance );
   ObjectSet(sign1xx, OBJPROP_YDISTANCE, 10+y_distance );
   
   iMAX_Curr=iCustom(NULL, PERIOD_D1, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_D1, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="D1"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="D1"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="D1"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="D1"; Col=Tomato; } //Trend Down Weak
   string sign2xx = "iMAX D1";
   ObjectDelete(sign2xx);
   ObjectCreate(sign2xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign2xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign2xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign2xx, OBJPROP_XDISTANCE, 60+x_distance );
   ObjectSet(sign2xx, OBJPROP_YDISTANCE, 10+y_distance );
   
   iMAX_Curr=iCustom(NULL, PERIOD_H4, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_H4, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="H4"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="H4"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="H4"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="H4"; Col=Tomato; } //Trend Down Weak
   string sign13xx = "iMAX H4";
   ObjectDelete(sign13xx);
   ObjectCreate(sign13xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign13xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign13xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign13xx, OBJPROP_XDISTANCE, 80+x_distance );
   ObjectSet(sign13xx, OBJPROP_YDISTANCE, 10+y_distance );
   
   iMAX_Curr=iCustom(NULL, PERIOD_H1, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_H1, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="H1"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="H1"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="H1"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="H1"; Col=Tomato; } //Trend Down Weak
   string sign23xx = "iMAX H1";
   ObjectDelete(sign23xx);
   ObjectCreate(sign23xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign23xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign23xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign23xx, OBJPROP_XDISTANCE, 100+x_distance );
   ObjectSet(sign23xx, OBJPROP_YDISTANCE, 10+y_distance );

   iMAX_Curr=iCustom(NULL, PERIOD_M30, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_M30, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M30"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M30"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M30"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M30"; Col=Tomato; } //Trend Down Weak
   string sign33xx = "iMAX M30";
   ObjectDelete(sign33xx);
   ObjectCreate(sign33xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign33xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign33xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign33xx, OBJPROP_XDISTANCE, 120+x_distance );
   ObjectSet(sign33xx, OBJPROP_YDISTANCE, 10+y_distance );

   iMAX_Curr=iCustom(NULL, PERIOD_M15, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_M15, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M15"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M15"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M15"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M15"; Col=Tomato; } //Trend Down Weak
   string sign35xx = "iMAX M15";
   ObjectDelete(sign35xx);
   ObjectCreate(sign35xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign35xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign35xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign35xx, OBJPROP_XDISTANCE, 150+x_distance );
   ObjectSet(sign35xx, OBJPROP_YDISTANCE, 10+y_distance );
   
   iMAX_Curr=iCustom(NULL, PERIOD_M5, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_M5, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M5"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M5"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M5"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M5"; Col=Tomato; } //Trend Down Weak
   string sign34xx = "iMAX M5";
   ObjectDelete(sign34xx);
   ObjectCreate(sign34xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign34xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign34xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign34xx, OBJPROP_XDISTANCE, 180+x_distance );
   ObjectSet(sign34xx, OBJPROP_YDISTANCE, 10+y_distance );
   
   iMAX_Curr=iCustom(NULL, PERIOD_M1, "iMAX",0,0);
   iMAX_Prev=iCustom(NULL, PERIOD_M1, "iMAX",1,0);
   if (iMAX_Curr==iMAX_Prev) { Sign=""; Col=DarkOrange; } //Sideway   
   if (iMAX_Curr>iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M1"; Col=Lime; } //Trend Up Strong
   if (iMAX_Curr<iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M1"; Col=Red; } //Trend Down Strong
   if (iMAX_Curr>iMAX_Prev && Close[0]<iMAX_Curr) { Sign="M1"; Col=LimeGreen; } //Trend Up Weak
   if (iMAX_Curr<iMAX_Prev && Close[0]>iMAX_Curr) { Sign="M1"; Col=Tomato; } //Trend Down Weak
   string sign343xx = "iMAX M1";
   ObjectDelete(sign343xx);
   ObjectCreate(sign343xx, OBJ_LABEL, 0, 0, 0 );
   ObjectSetText(sign343xx, Sign ,9, "Arial Bold", Col);
   ObjectSet(sign343xx, OBJPROP_CORNER, Corner );
   ObjectSet(sign343xx, OBJPROP_XDISTANCE, 200+x_distance );
   ObjectSet(sign343xx, OBJPROP_YDISTANCE, 10+y_distance );


//----
   return(0);
  }
//+------------------------------------------------------------------+